//+------------------------------------------------------------------+
//|                                      Cross_Trader_for_Manual.mq4 |
//|                                                  Nicholas Barker |
//|                                                 www.apexpips.com |
//+------------------------------------------------------------------+
#property copyright "Nicholas Barker"
#property link      "www.apexpips.com"

/*
Copyright Notice and License Agreements
Nicholas Barker - Copyright  2006 Apex Group Investments, LLC.

AGI software [both binary and source (if released)] (hereafter, Software) is intellectual property owned by AGI and 
is copyright of AGI in all countries in the world, and ownership remains with AGI.

You (hereafter, Licensee) may download the AGI software and install it for a testing and evaluation.
Beginning on the 91st day after installation of the Software, Licensee is required to acquire a license for future 
usage of the Software. A licence can be acquired by payment of a licence fee. Schools and universities may apply for 
an royalty-free licence for educational usage. (Licenses are distributed by OrbiTeam Software GmbH, a FIT spin-off 
company. Please send an email to license@orbiteam.de for details.) 

Licensee is not allowed to distribute the binary and source code (if released) to third parties. Licensee is not 
allowed to reverse engineer, disassemble or decompile code, or make any modifications of the binary or source code, 
remove or alter any trademark, logo, copyright or other proprietary notices, legends, symbols, or labels in the 
Software. 

Licensee is not allowed to sub-license the Software or any derivative work based on or derived from the Software. 

The Licensee acknowledges and agrees that the software is delivered 'as is' without warranty and without any support 
services (unless agreed otherwise with FIT or OrbiTeam). FIT and OrbiTeam make no warranties, either expressed or 
implied, as to the software and its derivatives. 

It is understood by Licensee that neither FIT nor OrbiTeam shall be liable for any loss or damage that may arise, 
including any indirect special or consequential loss or damage in connection with or arising from the performance 
or use of the software, including fitness for any particular purpose. 

By using or copying this Software, Licensee agrees to abide by the copyright law and all other applicable laws of 
Germany including, but not limited to, export control laws, and the terms of this licence. FIT and/or OrbiTeam shall 
have the right to terminate this licence immediately by written notice upon Licensee's breach of, or non-compliance 
with, any of its terms. Licensee may be held legally responsible for any copyright infringement that is caused or 
encouraged by Licensee's failure to abide by the terms of this licence. 




*/









#include <stdlib.mqh>
#define SL 0
#define TP 1
#define GET 2
#define SET 3


extern bool       DEBUG                   = false;
extern bool       TradeBUY                = false;
extern bool       TradeSELL               = false;
string            symbol                  = "";

extern double     lots                    = 10;
extern int        stoploss                = 0;
extern int        takeprofit              = 0;
extern bool       OverrideMINLOT          = false;


int     TradeOperation;
string pair[7]={
"EURUSD",
"GBPUSD",
"USDCHF",
"USDJPY",
"AUDUSD",
"USDCAD",
"NZDUSD"
};

int  MAGIC;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init(){
   if(!GlobalVariableCheck("CrossMagic")){
      GlobalVariableSet("CrossMagic",51150);
   } 
   if(!IsDemo()) return(0); 
   MAGIC=GlobalVariableGet("CrossMagic");  
   //if(symbol=="" || symbol=="CHART") 
   symbol=Symbol();
   Comment("\nSTART ",symbol);
   Sleep(0);
   int mag=GlobalVariableGet(symbol+"_M");
   int cnt=ordercnt(mag);
   if(cnt>0){
      if(GlobalVariableGet(symbol+"_type")==OP_BUY)TradeOperation=OP_BUY;
      if(GlobalVariableGet(symbol+"_type")==OP_SELL)TradeOperation=OP_SELL;
      setsltp();
      return;
   }
   if(TradeBUY && TradeSELL){
      Comment("\nWARNING! Opposing Trades - intervention required.");
      Alert("\nWARNING! OpposingTrades - intervention required.");
      return(0);
   }
   if(TradeBUY)TradeOperation=OP_BUY;
   else if(TradeSELL)TradeOperation=OP_SELL;
   main();
 
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit(){

   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start(){
   if(!IsDemo()) return(0);
   CheckClose();
   
   return(0);
}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void CheckClose(){
   if(TradeOperation==OP_BUY){
      Comment("Global SL = ",globe(GET,0,SL)," TP = ",globe(GET,0,TP));
      if(MarketInfo(symbol,MODE_BID)>=globe(GET,0,TP) && globe(GET,0,TP)!=0)closeorder();
      if(MarketInfo(symbol,MODE_BID)<=globe(GET,0,SL) && globe(GET,0,SL)!=0)closeorder();
      
   }
   else if(TradeOperation==OP_SELL){
      Comment("Global SL = ",globe(GET,0,SL)," TP = ",globe(GET,0,TP));
      if(MarketInfo(symbol,MODE_ASK)<=globe(GET,0,TP) && globe(GET,0,TP)!=0)closeorder();
      if(MarketInfo(symbol,MODE_ASK)>=globe(GET,0,SL) && globe(GET,0,SL)!=0)closeorder();
      
   }
}

int tkt3[50];
int ordercnt(int mag){
   int c;
   for(int i=0;i<OrdersTotal();i++){
      if(OrderSelect(i,SELECT_BY_POS)){
         if(OrderMagicNumber()==mag){
            tkt3[c]=OrderTicket();
            c++;
         }
      }
   }
   return(c);
}
//////////////////////////////////////////////////////////////////////////////////////////////
bool OrderMatch(int i){//
   if(OrderSelect(tkt3[i],SELECT_BY_TICKET) )return(true);else return(false);
}

int closeorder(){
   int mag=GlobalVariableGet(symbol+"_M");int c;
   int cnt=ordercnt(mag);
   for(int i=0;i<cnt;i++){
      if(OrderMatch(i)){
      
         while(true){
            RefreshRates();
            if(OrderType()==OP_BUY){
               double price=MarketInfo(OrderSymbol(),MODE_BID);
            }
            if(OrderType()==OP_SELL){
               price=MarketInfo(OrderSymbol(),MODE_ASK);
            }
            bool res = OrderClose(OrderTicket(),OrderLots(),price,1,White);
            if(res)return(res);
            c++;
            Print(ErrorDescription(GetLastError()));
            if(c>=10)return(-1);
            Sleep(500);
         }
      }
   }
}
      

void main(){  
   if(!TradeBUY && !TradeSELL){
      Comment("\nWARNING! no trade operation selected - intervention required.");
      Alert("\nWARNING! no trade operation selected - intervention required.");
      return;
   }   
   string s1=StringSubstr(symbol,0,3);
   string s2=StringSubstr(symbol,3,6);
   int trade1,trade2,i1delta,i2delta;
   for(int i=0;i<7;i++){
      int index1=StringFind(pair[i],s1);
      int index2=StringFind(pair[i],s2);
      if(index1>=0){
         trade1=i;
         i1delta=index1;
      }
      if(index2>=0){
         trade2=i;
         i2delta=index2;
      }
   }
   int mag=GlobalVariableGet(symbol+"_M");
   
   Comment("TRADE1 ",trade1," ",pair[trade1]);
   Sleep(0);
   Comment("TRADE2 ",trade2," ",pair[trade2]);
   Sleep(0);
   int sf1=StringFind(pair[trade1],"USD",0);
   int sf2=StringFind(pair[trade2],"USD",0);  
   if(sf1==0){
      if(TradeOperation==OP_BUY)int dir1=OP_SELL;
      else if(TradeOperation==OP_SELL)dir1=OP_BUY;
      double factor1=1; //MarketInfo(pair[trade1],MODE_BID);
   }else{ 
      if(TradeOperation==OP_BUY)dir1=OP_BUY;
      else if(TradeOperation==OP_SELL) dir1=OP_SELL;
      factor1=1/MarketInfo(pair[trade1],MODE_BID);
   }
   if(sf2==0){
      if(TradeOperation==OP_BUY)int dir2=OP_BUY;
      else if(TradeOperation==OP_SELL)dir2=OP_SELL;
      double factor2=1; //MarketInfo(pair[trade2],MODE_BID);
   }else{ 
      if(TradeOperation==OP_BUY)dir2=OP_SELL;
      else if(TradeOperation==OP_SELL)dir2=OP_BUY;
      factor2=1/MarketInfo(pair[trade2],MODE_BID);
   }
   double factoralpha=(factor2/factor1);
   double lots1=lots/(1+factoralpha);
   double lots2=lots1*factoralpha;
   int digit =2;
   if(!OverrideMINLOT){
      double minlot=MarketInfo(pair[trade1],MODE_MINLOT);
      if(minlot==0.01)digit=2;
      else if(minlot==0.1)digit=1;
      else if(minlot==1)digit=0;
   }
   lots1=NormalizeDouble(lots1,digit);
   lots2=NormalizeDouble(lots2,digit);
   Comment("\nFactor1 ",pair[trade1]," ",factor1,
   "\nFactor2 ",pair[trade2]," ",factor2,
   "\nfactoralpha ",factoralpha,
   "\nLots1 ",lots1,"  Lots2 ",lots2);
   Sleep(0);

   GlobalVariableSet( "CrossMagic",GlobalVariableGet("CrossMagic") +1 );
   GlobalVariableSet(symbol+"_M", GlobalVariableGet("CrossMagic"));
   MAGIC=GlobalVariableGet("CrossMagic");
   if(dir1==OP_BUY)GlobalVariableSet(symbol+"_type",OP_BUY);
   if(dir1==OP_SELL)GlobalVariableSet(symbol+"_type",OP_SELL);
   if(!DEBUG){
      if(SendOrder(pair[trade1],dir1,lots1)){
         if(SendOrder(pair[trade2],dir2,lots2)){
            setsltp();
         }else Alert("WARNING !!! Trade failed on ",trade2);
      }else Alert("WARNING !!! Trade failed on ",trade1);
   }
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
bool SendOrder(string sym,int dir,double llot){
   int c;
   while(true){
      if(dir==OP_BUY){double price=MarketInfo(sym,MODE_ASK);color clr=Blue;}
      else {price=MarketInfo(sym,MODE_BID);clr=Red;}
      int res = OrderSend(sym,dir,llot,price,1,0,0,"Manual_Cross",MAGIC,0,clr);
      if(res>=0)return(true);
      Print(ErrorDescription(GetLastError()));
      Sleep(30);
      RefreshRates();
      c++;
      if(c>=10)return(false);
   }
}

void setsltp(){
   if(TradeOperation==OP_BUY){
      if(stoploss==0)double sl=0;
      else sl=  MarketInfo(symbol,MODE_BID) - stoploss*MarketInfo(symbol,MODE_POINT);
      globe(SET,sl,SL);
      if(takeprofit==0)double tp=0;
      else tp=  MarketInfo(symbol,MODE_BID) + takeprofit*MarketInfo(symbol,MODE_POINT);
      globe(SET,tp,TP);
   }
   else if(TradeOperation==OP_SELL){
      if(stoploss==0) sl=0;
      else sl=  MarketInfo(symbol,MODE_ASK) + stoploss*MarketInfo(symbol,MODE_POINT);
      globe(SET,sl,SL);
      if(takeprofit==0) tp=0;
      else tp=  MarketInfo(symbol,MODE_ASK) - takeprofit*MarketInfo(symbol,MODE_POINT);
      globe(SET,tp,TP);
   }
}
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
double globe(int mode,double value,int SLTP){
   if(SLTP==SL)string name=symbol+"_SL";else name=symbol+"_TP";
   if(mode==SET)return(GlobalVariableSet(name,value));
   if(mode==GET)return(GlobalVariableGet(name));
}
         